#!/usr/bin/python3

import pynwp.migration as core
import sys


def validator(args):
    if not args.current_version or not args.target_version or not args.rootfs or not args.patches_path:
        return False
    else:
        return True


if __name__ == "__main__":
    arguments = core.CommandLineParser(sys.argv[1:], validator)

    if arguments.is_upgrade():
        incremental_updates = core.IncrementalUpdates(current_version=arguments.current_version(),
                                                      target_version=arguments.target_version(),
                                                      patches_path=arguments.patches_path(),
                                                      rootfs=arguments.rootfs_path(),
                                                      board_type=core.SystemUtil.board_type())
        print("Executing permanent patches")
        incremental_updates.execute_permanent_patches()

        message = "Executing upgrade patches"
        if not arguments.is_clean():
            print(message)
            incremental_updates.execute_upgrade_patches()
        else:
            print(message + " - skipped")
