class DeviceInfo:
    def __init__(self, model_info):
        model_lines = model_info.splitlines(True)

        self.__product = model_lines[0].strip().decode("utf-8")
        self.__model_number = model_lines[1].strip().split()[-1].decode("utf-8")
        self.__serial_number = model_lines[2].strip().split()[-1].decode("utf-8")

        self.__board_type = self.__get_board_type()

    def product(self):
        return self.__product

    def model_number(self):
        return self.__model_number

    def serial_number(self):
        return self.__serial_number

    def board_type(self):
        return self.__board_type

    def __get_board_type(self):
        board_type_number = int(self.__model_number.split('-')[0])

        if board_type_number == 1228:
            return "matchbox"

        if board_type_number == 1227:
            return "sketch"

        return "unknown"
