from .UsersService import UsersService


class UsersTransfer:
    def __init__(self, target_rootfs):
        self.__current_rootfs = "/"
        self.__target_rootfs = target_rootfs

    def copy_users_changes(self, uid):
        current_users = UsersService.get_user_names_by_uid(self.__current_rootfs, uid)
        target_users = UsersService.get_user_names_by_uid(self.__target_rootfs, uid)

        UsersService.update_passwd(self.__target_rootfs, current_users, uid)

        if not UsersService.is_names_unique(self.__target_rootfs):
            raise Exception("Target rootfs contains duplication user names")

        passwords = UsersService.get_passwords(self.__current_rootfs, current_users)
        UsersService.update_shadow(self.__target_rootfs, target_users, current_users, passwords)
        UsersService.update_group(self.__target_rootfs, target_users, current_users)

    def copy_existing_users(self, gid, additional_gid, except_uid):
        uid = UsersService.get_users_id_by_gid(self.__current_rootfs, gid)
        uid = [user_id for user_id in uid if user_id not in except_uid]

        current_users = UsersService.get_user_names_by_uid(self.__current_rootfs, uid)
        UsersService.copy_users(self.__current_rootfs, self.__target_rootfs, current_users, additional_gid)
